/**
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 *
 * Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

package fixtures.bodycomplex;

import com.microsoft.rest.ServiceClient;
import com.squareup.okhttp.OkHttpClient;
import retrofit.Retrofit;

/**
 * Initializes a new instance of the AutoRestComplexTestService class.
 */
public final class AutoRestComplexTestServiceImpl extends ServiceClient implements AutoRestComplexTestService {
    /**
     * The URI used as the base for all cloud service requests.
     */
    private final String baseUri;

    /**
     * Gets the URI used as the base for all cloud service requests.
     * @return The BaseUri value.
     */
    public String getBaseUri() {
        return this.baseUri;
    }

    /**
     * Gets the BasicOperations object to access its operations.
     * @return the basicOperations value.
     */
    public BasicOperations getBasicOperations() {
        return new BasicOperationsImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the Primitive object to access its operations.
     * @return the primitive value.
     */
    public Primitive getPrimitive() {
        return new PrimitiveImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the Array object to access its operations.
     * @return the array value.
     */
    public Array getArray() {
        return new ArrayImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the Dictionary object to access its operations.
     * @return the dictionary value.
     */
    public Dictionary getDictionary() {
        return new DictionaryImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the Inheritance object to access its operations.
     * @return the inheritance value.
     */
    public Inheritance getInheritance() {
        return new InheritanceImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the Polymorphism object to access its operations.
     * @return the polymorphism value.
     */
    public Polymorphism getPolymorphism() {
        return new PolymorphismImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Gets the Polymorphicrecursive object to access its operations.
     * @return the polymorphicrecursive value.
     */
    public Polymorphicrecursive getPolymorphicrecursive() {
        return new PolymorphicrecursiveImpl(this.retrofitBuilder.build(), this);
    }

    /**
     * Initializes an instance of AutoRestComplexTestService client.
     */
    public AutoRestComplexTestServiceImpl() {
        this("http://localhost");
    }

    /**
     * Initializes an instance of AutoRestComplexTestService client.
     *
     * @param baseUri the base URI of the host
     */
    public AutoRestComplexTestServiceImpl(String baseUri) {
        super();
        this.baseUri = baseUri;
        initialize();
    }

    /**
     * Initializes an instance of AutoRestComplexTestService client.
     *
     * @param baseUri the base URI of the host
     * @param client the {@link OkHttpClient} client to use for REST calls
     * @param retrofitBuilder the builder for building up a {@link Retrofit}
     */
    public AutoRestComplexTestServiceImpl(String baseUri, OkHttpClient client, Retrofit.Builder retrofitBuilder) {
        super(client, retrofitBuilder);
        this.baseUri = baseUri;
        initialize();
    }

    private void initialize() {
        this.retrofitBuilder.baseUrl(baseUri);
    }
}
