/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

var models = require('./index');

/**
 * @class
 * Initializes a new instance of the Bar class.
 * @constructor
 * The URIs that are used to perform a retrieval of a public blob, queue or
 * table object.
 * @member {object} [recursivePoint] Recursive Endpoints
 * 
 * @member {string} [recursivePoint.blob] Gets the blob endpoint.
 * 
 * @member {string} [recursivePoint.queue] Gets the queue endpoint.
 * 
 * @member {string} [recursivePoint.table] Gets the table endpoint.
 * 
 * @member {object} [recursivePoint.dummyEndPoint] Dummy EndPoint
 * 
 * @member {object} [recursivePoint.fooPoint] Foo point
 * 
 * @member {object} [recursivePoint.fooPoint.barPoint] Bar point
 * 
 */
function Bar(parameters) {
  if (parameters !== null && parameters !== undefined) {
    if (parameters.recursivePoint) {
      this.recursivePoint = new models['Endpoints'](parameters.recursivePoint);
    }
  }    
}


/**
 * Validate the payload against the Bar schema
 *
 * @param {JSON} payload
 *
 */
Bar.prototype.serialize = function () {
  var payload = {};
  if (this['recursivePoint']) {
    payload['RecursivePoint'] = this['recursivePoint'].serialize();
  }

  return payload;
};

/**
 * Deserialize the instance to Bar schema
 *
 * @param {JSON} instance
 *
 */
Bar.prototype.deserialize = function (instance) {
  if (instance) {
    if (instance['RecursivePoint']) {
      this['recursivePoint'] = new models['Endpoints']().deserialize(instance['RecursivePoint']);
    }
  }

  return this;
};

module.exports = Bar;
