/*
 * Copyright (c) Microsoft Corporation. All rights reserved.
 * Licensed under the MIT License. See License.txt in the project root for
 * license information.
 * 
 * Code generated by Microsoft (R) AutoRest Code Generator 0.14.0.0
 * Changes may cause incorrect behavior and will be lost if the code is
 * regenerated.
 */

'use strict';

/**
 * @class
 * Initializes a new instance of the SampleResourceGroup class.
 * @constructor
 * @member {string} [name] resource group name 'testgroup101'
 * 
 * @member {string} [location] resource group location 'West US'
 * 
 */
function SampleResourceGroup(parameters) {
  if (parameters !== null && parameters !== undefined) {
    if (parameters.name !== undefined) {
      this.name = parameters.name;
    }
    if (parameters.location !== undefined) {
      this.location = parameters.location;
    }
  }    
}


/**
 * Validate the payload against the SampleResourceGroup schema
 *
 * @param {JSON} payload
 *
 */
SampleResourceGroup.prototype.serialize = function () {
  var payload = {};
  if (this['name'] !== null && this['name'] !== undefined) {
    if (typeof this['name'].valueOf() !== 'string') {
      throw new Error('this[\'name\'] must be of type string.');
    }
    payload['name'] = this['name'];
  }

  if (this['location'] !== null && this['location'] !== undefined) {
    if (typeof this['location'].valueOf() !== 'string') {
      throw new Error('this[\'location\'] must be of type string.');
    }
    payload['location'] = this['location'];
  }

  return payload;
};

/**
 * Deserialize the instance to SampleResourceGroup schema
 *
 * @param {JSON} instance
 *
 */
SampleResourceGroup.prototype.deserialize = function (instance) {
  if (instance) {
    if (instance['name'] !== undefined) {
      this['name'] = instance['name'];
    }

    if (instance['location'] !== undefined) {
      this['location'] = instance['location'];
    }
  }

  return this;
};

module.exports = SampleResourceGroup;
